/*
 * $Id: propertydata.h,v 1.8 2005/12/02 12:47:52 ozawa Exp $
 *
 * Copyright 2003- ONGS Inc. All rights reserved.
 *
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.8 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___PROPERTYDATA_H
#define ___PROPERTYDATA_H

#include "gtkmm.h"
#include "libxml/parser.h"
#include "libxml/tree.h"

#define DEFAULT_FONTNAME          "Gothic 10"
#define DEFAULT_WRAPMODE          Gtk::WRAP_NONE;

#define PTYPE_NICKNAME            "Nickname"
#define PTYPE_BG_COLOR            "Background-Color"
#define PTYPE_FG_COLOR            "Foreground-Color"
#define PTYPE_FONTNAME            "FontName"
#define PTYPE_WRAPMODE            "WrapMode"
#define PTYPE_PRINT_COMMAND       "PrintCommand"
#define PTYPE_ENABLE_NETWORK      "EnableNetwork"
#define PTYPE_BROADCAST_ADDR      "BroadcastAddr"
#define PTYPE_STICK_WND           "StickWnd"
#define PTYPE_TRAYICON            "TrayIcon"
#define PTYPE_HIDEMAINWND         "HideMainWnd"

#define MAX_NICKNAME_LEN          40  // 40ʸʥХȤǤϤʤ

typedef std::list<Glib::ustring>    BroadcastList;

extern Glib::ustring getPropertyFilePath();

class PropertyData {
public:
    /**
     * 󥹥ȥ饯
     */
    PropertyData();

    /**
     * ԡ󥹥ȥ饯
     */
    PropertyData(const PropertyData& data);

    /**
     * ǥȥ饯
     */
    virtual ~PropertyData();

public:
    /**
     * ֥ɥ㥹ȥɥ쥹ɲäޤ
     * 
     * @param szAddr ֥ɥ㥹ȥɥ쥹
     */
    void addBroadcastAddr(Glib::ustring szAddr);

    /**
     * ֥ɥ㥹ȥɥ쥹ΰˤޤ
     */
    void clearBroadcastList();

    /**
     * طʿޤ
     * 
     * @return طʿᤷޤ
     *         ᤵطʿϻȥΤ߲ǽǤ
     *         ѹ϶ػߤǤ
     */
    const GdkColor* getBackground() const;

    /**
     * ֥ɥ㥹ȥɥ쥹ΰޤ
     * 
     * @return ֥ɥ㥹ȥɥ쥹ΰ
     */
    const BroadcastList& getBroadcastList() const;

    /**
     * ե̾ޤ
     * 
     * @return ե̾ᤷޤ
     */
    Glib::ustring getFontName() const;
    
    /**
     * ʿޤ
     * 
     * @return ʿᤷޤ
     *         ᤵʿϻȥΤ߲ǽǤ
     *         ѹ϶ػߤǤ
     */
    const GdkColor* getForeground() const;
    
    /**
     * ˥å͡ޤ
     * 
     * @return ˥å͡ᤷޤ
     */
    Glib::ustring getNickName() const;

    /**
     * ѤΥޥɤޤ
     * 
     * @return ѤΥޥɤᤷޤ
     */
    Glib::ustring getPrintCommand() const;
    
    /**
     * ޤ֤⡼ɤޤ
     * 
     * @return ޤ֤⡼
     */
    Gtk::WrapMode getWrapMode() const;

    /**
     * ͥåȥǽѤ뤫Ĵ٤ޤ
     * 
     * @return ͥåȥǽͭʾ true ᤷޤ
     */
    bool isEnableNetwork() const;
    
    /**
     * ᥤ󥦥ɥɽˤ뤫Ĵ٤ޤ
     * 
     * @return ᥤ󥦥ɥɽˤ true ᤷޤ
     */
    bool isHideMainWnd() const;
    
    /**
     * ɥĥդ֤ˤ뤫Ĵ٤ޤ
     * 
     * @return ĥդ֤ˤ true ᤷޤ
     */
    bool isStickWindow() const;
    
    /**
     * ȥ쥤ͭˤ뤫Ĵ٤ޤ
     * 
     * @return ȥ쥤ͭˤ true ᤷޤ
     */
    bool isTrayIcon() const;

    /**
     * ֥ɥ㥹ȥɥ쥹ΰꤷޤ
     * 
     * @param broadcastList ֥ɥ㥹ȥɥ쥹ΰ
     */
    void setBroadcastList(const BroadcastList& broadcastList);

    /**
     * طʿꤷޤ
     * 
     * @param pColor طʿ
     */
    void setBackground(const GdkColor* pColor);

    /**
     * ͥåȥǽѤ뤫ꤷޤ
     * 
     * @param bEnable ͥåȥǽͭˤ true ꤷޤ
     */
    void setEnableNetwork(bool bEnable);

    /**
     * ե̾ꤷޤ
     * 
     * @param szFontName ե̾
     */
    void setFontName(Glib::ustring szFontName);

    /**
     * ʿꤷޤ
     * 
     * @param pColor ʿ
     */
    void setForeground(const GdkColor* pColor);

    /**
     * ᥤ󥦥ɥɽˤ뤫ꤷޤ
     * 
     * @param bHideMainWnd ᥤ󥦥ɥɽˤ true ꤷޤ
     */
    void setHideMainWnd(bool bHideMainWnd);

    /**
     * ˥å͡ꤷޤ
     * 
     * @param szNickName ˥å͡
     */
    void setNickName(const Glib::ustring szNickName);

    /**
     * ѤΥޥɤޤ
     * 
     * @param szPrintCommand ѤΥޥ
     */
    void setPrintCommand(const Glib::ustring szPrintCommand);

    /**
     * ɥĥդ֤ˤ뤫ꤷޤ
     * 
     * @param bPaste ĥդ֤ˤ true ꤷޤ
     */
    void setStickWindow(bool bPaste);
    
    /**
     * ȥ쥤ɽ뤫ꤷޤ
     * 
     * @param bTrayIcon ȥ쥤ɽ true ꤷޤ
     */
    void setTrayIcon(bool bTrayIcon);

    /**
     * ޤ֤⡼ɤꤷޤ
     * 
     * @param nWrapMode ޤ֤⡼
     */
    void setWrapMode(Gtk::WrapMode nWrapMode);

public:
    /**
     * ʣ
     */
    PropertyData& operator=(const PropertyData& data);
    
    /**
     * 
     */
    bool operator==(const PropertyData& data) const;

    /**
     * 
     */
    bool operator!=(const PropertyData& data) const;

public:
    /**
     * ץѥƥޤ
     * 
     * @return ץѥƥ
     */
    static const PropertyData& get();
     
    /**
     * ץѥƥ꡿¸ޤ
     * 
     * @param property ץѥƥ
     * @param save ե¸ true ꤷޤ
     */
    static void set(const PropertyData& property, bool save = false);
     
public:
    /**
     * ꥢ饤줿ץѥƥץѥƥ֥Ȥ
     * ۤޤ
     * 
     * @param pData ꥢ饤ΥХ
     * @return ץѥƥ֥ȡ
     *         פˤʤäʳ˴ɬפޤ
     */
    static PropertyData buildObject(const char* pData);

    /**
     * ץѥƥ֥Ȥ򥷥ꥢ饤ޤ
     * 
     * @param property ץѥƥ֥
     * @return ꥢ饤ΥХ
     *         פˤʤäʳ˴ɬפޤ
     */
    static char* toSerializedString(const PropertyData& property);

private:
    /**
     * 䵻Υץѥƥɤ߹ߤޤ
     * 
     * @return ɤ䵻Υץѥƥᤷޤ
     */
    static PropertyData loadProperty();

    /**
     * 䵻Υץѥƥ¸ޤ
     * 
     * @param property 䵻ץѥƥ
     * @return ¸ true ᤷޤ
     */
    static bool saveProperty(const PropertyData& property);

private:
    /**
     * 䵻ΥץѥƥXMLɤ߹ߤޤ
     * 
     * @param document XML
     * @param property ץѥƥ¸襪֥
     * @return ɤtrueᤷޤ
     */
    static bool loadFromXML(const xmlDocPtr document, PropertyData& property);

    /**
     * 䵻ΥץѥƥXMLѴޤ
     * 
     * @param property 䵻ץѥƥ
     * @return ѴXMLפˤʤäǲɬפޤ
     */
    static xmlDocPtr toXML(const PropertyData& property);
    
private:
    /**
     * ɺѤߤΥץѥƥ
     */
    static PropertyData m_cProperty;

private:
    /**
     * ˥å͡
     */
    Glib::ustring m_szNickName;

    /**
     * ʡطʿ
     */
    GdkColor m_cForeground;
    GdkColor m_cBackground;

    /**
     * եȾ̾
     */
    Glib::ustring m_szFontName;
    
    /**
     * ޤ֤⡼
     */
    Gtk::WrapMode m_nWrapMode;

    /**
     * ͥåȥǽͭե饰
     */
    bool m_bEnableNetwork;

    /**
     * ޥ
     */
    Glib::ustring m_szPrintCommand;

    /**
     * ֥ɥ㥹ȥɥ쥹ΰ
     */
    BroadcastList m_cBroadcastList;
    
    /**
     * ɥŽդե饰
     */
    bool m_bStickWindow;
    
    /**
     * ȥ쥤ɽե饰
     */
    bool m_bTrayIcon;
    
    /**
     * ᥤ󥦥ɥɽե饰
     */
    bool m_bHideMainWnd;
};

#endif
