/*
 * $Id: fusenshisocket.cpp,v 1.1 2005/12/02 07:08:01 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.1 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#include "../include/fusenshi.h"
#include "fusenshisocket.h"

FusenshiSocket::FusenshiSocket()
{
    m_socket = -1;
}

FusenshiSocket::FusenshiSocket(FusenshiSocket& sock)
{
    m_socket = sock.m_socket;
}

FusenshiSocket::~FusenshiSocket()
{
    close();
}

int FusenshiSocket::select(struct timeval& timeout)
{
    if (0 > m_socket) return -1;

    fd_set rfds;

    FD_ZERO(&rfds);
    FD_SET(m_socket, &rfds);

    return ::select(m_socket +1, &rfds, NULL, NULL, &timeout);
}

int FusenshiSocket::shutdown()
{
    if (0 > m_socket) return -1;
    return ::shutdown(m_socket, SHUT_RDWR);
}

int FusenshiSocket::close()
{
    shutdown();
    
    if (0 > m_socket) return 0;

    int result = ::close(m_socket);
    if (!result) {
        m_socket = -1;
    }
    
    return result;
}

bool FusenshiSocket::operator()()
{
    return (0 <= m_socket);
}
