/*
 * $Id: net.h,v 1.4 2005/12/02 12:03:47 ozawa Exp $
 *
 * Copyright 2003- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.4 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___NET_H
#define ___NET_H

#ifndef __cplusplus
#define __cplusplus
#endif

#include <unistd.h>

#include <openssl/crypto.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/rand.h>

#define FUSENSHI_PORT           21006

#define FUSENSHI_NET_PROTO_MAJOR_VERSION    0x00
#define FUSENSHI_NET_PROTO_MINOR_VERSION    0x07

#define FNET_CMD_REQUEST        0x01
#define FNET_CMD_RESPONSE       0x02

#define FNET_EXT_SSL            0x00000001    // supported SSL

/**
 * ۥȾΥѥåȹ¤
 * 
 * [COMMANDTYPE=1byte][MAJORVERSION=1byte][MINORVERSION=1byte]
 * [EXTINFO=4byte][NICKNAME=?byte][HOSTNAME=?byte]
 * 
 * NICKNAMEι¤
 * 
 * [LENGTH=4byte][NICKNAME=LENGTH byte]
 * 
 * HOSTNAMEι¤
 * 
 * [LENGTH=4byte][HOSTNAME=LENGTH byte]
 * 
 * NICKNAMEϾUTF-8󥳡ɤǤ
 * HOSTNAMEϾASCII󥳡ɤǤ
 */

#define MAX_HOST_INFO_LENGTH    1024                    // ۥȾκĹUDPѥåѡ1414ޤǤȤ뤳ȡ

/**
 * 䵻ǡΥѥåȹ¤
 * 
 * [HEADER=?byte][DATA=?byte]
 * 
 * HEADERι¤
 * 
 * [LENGTH=4byte][HOSTINFO=LENGTH byte]
 * 
 * HOSTINFOι¤
 * 
 * [NICKNAME=?byte][HOSTNAME=?byte]
 * 
 * NICKNAMEι¤
 * 
 * [LENGTH=4byte][NICKNAME=LENGTH byte]
 * 
 * HOSTNAMEι¤
 * 
 * [LENGTH=4byte][HOSTNAME=LENGTH byte]
 * 
 * DATAι¤
 * 
 * [LENGTH=4byte][FUSENSHIDATA=LENGTH byte]
 * 
 * FUSENSHIDATAϥꥢ饤Ѥߤ䵻ǡΤΡ
 */
#define MAX_EXT_INFO_LENGTH     MAX_HOST_INFO_LENGTH    // 䵻ոۥȾκĹ
                                                        //ʸߤϡ֥ۥȾפƱ󤷤ʤ
#define MAX_FUSENSHIDATA_LENGTH (1024 * 1024)           // 䵻ǡΤκĹ

#define NET_CLIENT_USER         "NetClientUser"
#define NET_CLIENT_HOST         "NetClientHost"
#define NET_CLIENT_IP           "NetClientIP"

#include "fusenshiserver.h"
#include "fusenshiclient.h"
#include "fusenshiserverinfo.h"

// ۥ̾Ĺ
#ifdef _SC_HOST_NAME_MAX
extern const long _HOST_NAME_MAX;
#else
# ifdef HOST_NAME_MAX
#  define _HOST_NAME_MAX HOST_NAME_MAX
# else
#  define _HOST_NAME_MAX 255
# endif
#endif

#endif
