/*
 * $Id: sourcetagtable.h,v 1.1 2005/04/08 20:11:22 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.1 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___SOURCETAGTABLE_H_
#define ___SOURCETAGTABLE_H_

#include <gtkmm.h>
#include <gtksourceview/gtksourcetagtable.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkSourceTagTable GtkSourceTagTable;
typedef struct _GtkSourceTagTableClass GtkSourceTagTableClass;
#endif // DOXYGEN_SHOULD_SKIP_THIS

namespace Gtk
{

class SourceTagTable;

class SourceTagTable_Class : public Glib::Class
{
public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
    typedef SourceTagTable CppObjectType;
    typedef GtkSourceTagTable BaseObjectType;
    typedef GtkSourceTagTableClass BaseClassType;
    typedef Gtk::TextTagTable_Class CppClassParent;
    typedef GtkTextTagTableClass BaseClassParent;

    friend class SourceTagTable;
#endif // DOXYGEN_SHOULD_SKIP_THIS

    const Glib::Class& init();

    static void class_init_function(void* g_class, void* class_data);

    static Glib::ObjectBase* wrap_new(GObject*);

protected:
    //Callbacks (default signal handlers):
    static void changed_callback(GtkSourceTagTable* self);
};


class SourceTagTable : public Gtk::TextTagTable
{
#ifndef DOXYGEN_SHOULD_SKIP_THIS
public:
    typedef SourceTagTable CppObjectType;
    typedef SourceTagTable_Class CppClassType;
    typedef GtkSourceTagTable BaseObjectType;
    typedef GtkSourceTagTableClass BaseClassType;

private:
    friend class SourceTagTable_Class;
    static CppClassType sourcetagtable_class_;

private:
    // noncopyable
    SourceTagTable(const SourceTagTable&);
    SourceTagTable& operator=(const SourceTagTable&);

protected:
    explicit SourceTagTable(const Glib::ConstructParams& construct_params);
    explicit SourceTagTable(GtkSourceTagTable* castitem);

#endif // DOXYGEN_SHOULD_SKIP_THIS

public:
    virtual ~SourceTagTable();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
    static GType get_type()      G_GNUC_CONST;
    static GType get_base_type() G_GNUC_CONST;
#endif // DOXYGEN_SHOULD_SKIP_THIS

    //Provides access to the underlying C GObject.
    GtkSourceTagTable* gobj() { return reinterpret_cast<GtkSourceTagTable*>(gobject_); }

    //Provides access to the underlying C GObject.
    const GtkSourceTagTable* gobj() const { return reinterpret_cast<GtkSourceTagTable*>(gobject_); }

    //Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
    GtkSourceTagTable* gobj_copy();

protected:
    SourceTagTable();

public:
    static Glib::RefPtr<SourceTagTable> create();

    Glib::SignalProxy0<void> signal_changed();

protected:
    //Default Signal Handlers::
    virtual void on_changed();
};

} /* namespace Gtk */


namespace Glib
{
    /** @relates Gtk::SourceTagTable
     * @param object The C instance
     * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
     * @result A C++ instance that wraps this C instance.
     */
    Glib::RefPtr<Gtk::SourceTagTable> wrap(GtkSourceTagTable* object, bool take_copy = false);
}

#endif //___SOURCETAGTABLE_H_
