/*
 * $Id: systemtrayicon.h,v 1.2 2005/02/04 18:26:14 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.2 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___SYSTEMTRAYICON_H
#define ___SYSTEMTRAYICON_H

#include "gtkmm.h"
#include "gtkmm/plug.h"
#include "gdk/gdkx.h"

typedef enum _SystemTrayOpCode {
    REQUEST_DOCK    = 0,
    BEGIN_MESSAGE   = 1,
    CANCEL_MESSAGE  = 2
} SystemTrayOpCode;

class SystemTrayIcon
{
public:
    SystemTrayIcon();
    SystemTrayIcon(int width, int height);
    SystemTrayIcon(int width, int height, Glib::RefPtr<Gdk::Pixbuf> icon);
    virtual ~SystemTrayIcon();
    
    /**
     * ȥ쥤򥷥ƥȥ쥤³ޤ
     */
    bool connect();
    
    /**
     * ƥȥ쥤ɥ¸ߤ뤫ǧޤ
     */
    bool existSystemTray();
    
    /**
     * ꤷޤ
     */
    void setIcon(Glib::RefPtr<Gdk::Pixbuf> icon);
    
    /**
     * ƥȥ쥤إХ롼ɽѤʸΤޤ
     */
    unsigned long sendMessageData(long timeout /* ms */, const Glib::ustring& message);
    
    /**
     * Х롼ɽѤʸ˴ޤ
     */
    bool cancelMessageData(unsigned long id);
    
    /**
     * ȥ쥤ɽƤ뤫ǧޤ
     */
    bool isViewable();
    
    /**
     * ƥȥ쥤ɥޥ͡ˤäƥݡȤ줿
     * ȯ륷ʥ
     */
    sigc::signal0<void> signal_systemtray_attach();
    
    /**
     * ƥȥ쥤˴ȯ륷ʥ
     */
    sigc::signal0<void> signal_systemtray_dettach();
    
    /**
     * ƥȥ쥤ؤϿȯ륷ʥ
     */
    sigc::signal0<void> signal_systemtrayicon_connected();

    /**
     * ƥȥ쥤Υޥåʥ
     */
    sigc::signal<bool, GdkEventButton*> signal_systemtrayicon_leftclicked();

    /**
     * ƥȥ쥤Υޥ֥륯åʥ
     */
    sigc::signal<bool, GdkEventButton*> signal_systemtrayicon_doubleclicked();

    /**
     * ƥȥ쥤Υޥåʥ
     */
    sigc::signal<bool, GdkEventButton*> signal_systemtrayicon_rightclicked();

protected:
    /**
     * ƥȥ쥤ݡȤ줿Υ٥Ȥα
     */
    virtual void on_systemtray_attach();
    
    /**
     * ƥȥ쥤˴줿Υ٥Ȥα
     */
    virtual void on_systemtray_dettach();
    
    /**
     * ƥȥ쥤ؤϿ٥Ȥα
     */
    virtual void on_systemtrayicon_connected();
    
    /**
     * ƥȥ쥤Υޥå
     */
    virtual bool on_systemtrayicon_leftclicked(GdkEventButton *pEvent);

    /**
     * ƥȥ쥤Υޥ֥륯å
     */
    virtual bool on_systemtrayicon_doubleclicked(GdkEventButton *pEvent);

    /**
     * ƥȥ쥤Υޥå
     */
    virtual bool on_systemtrayicon_rightclicked(GdkEventButton *pEvent);
    
private:
    /**
     * ƥȥ쥤Υ٥Ȥե륿
     */
    void st_event_filter(GdkXEvent *gdkxevent, GdkEvent *gdkevent);
    
    /**
     * ɥޥ͡Υ٥Ȥե륿
     */
    void wm_event_filter(GdkXEvent *gdkxevent, GdkEvent *gdkevent);
    
    /**
     * ȥ쥤Υ٥Ȥե륿
     */
    void wnd_event_filter
        (GdkXEvent *gdkxevent, GdkEvent *gdkevent, GdkFilterReturn *retcode);
    
private:
    /**
     * ȥ쥤ѤΥɥۤޤ
     */
    void create(int width, int height, Glib::RefPtr<Gdk::Pixbuf> icon);
    
    /**
     * ƥȥ쥤ɥ
     */
    ::Window getSystemTray();
    
    /**
     * ͥƥ֥ɥ
     */
    ::Window get_id();
    
    /**
     * GTKơޤޤɸΥꤹ
     */
    void resetStyle();
    
    /**
     * ɥ褹
     */
    void exposeWindow();
    
    /**
     * ƥȥ쥤إå롣
     */
    bool sendMessage(::Window window, SystemTrayOpCode opcode, ...);

private:
    Glib::RefPtr<Gdk::Window>   m_pWindow;
    Glib::RefPtr<Gdk::Pixbuf>   m_pIcon;
    Time        m_PrevButtonEventTime;
    guint        m_DoubleClickTime;
    
    Atom            m_OpAtom;
    Atom            m_DataAtom;
    Atom            m_TrayAtom;
    Atom            m_ManagerAtom;
    ::Window        m_TrayWnd;
    uint32_t        m_SequenceID;
    
    sigc::signal0<void> m_AttachSignal;
    sigc::signal0<void> m_DettachSignal;
    sigc::signal0<void> m_ConnectedSignal;
    
    sigc::signal<bool, GdkEventButton*> m_LeftClickSignal;
    sigc::signal<bool, GdkEventButton*> m_DoubleClickSignal;
    sigc::signal<bool, GdkEventButton*> m_RightClickSignal;
    
    sigc::connection    m_AttachConnect;
    sigc::connection    m_DettachConnect;
    sigc::connection    m_WndEventConnect;
};

#endif
